import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.awt.*;
/**
 * Write a description of class CherryWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class CherryWorld extends World
{

    public static final int TOTALCHERRIES=10;
    public static final int MapWidth=1280;
    public static final int MapHeight=512;
    private long tick,time,tempTime;
    private boolean canShowRank;
    private boolean isPaused;
    public static GreenfootImage backIm1,backIm2;
    public static tile firstTile; 

    public static boolean canScrollLeft=false;
    public static boolean canScrollRight=false;
    public static int scrollX;

    public enum Dir{East,North,South};
    private Dir direction=Dir.East;
    private int lastX,lastY;

    public CherryWorld()
    {   
        super(640+2*tile.SIZE, 512, 1,false); 
        GreenfootImage im=getBackground();
        backIm1=backIm2=new GreenfootImage(im);
        Font font = new Font("Arial", Font.BOLD, 30);
        im.setFont(font);
        im.setColor(Color.black);
        im.drawString("Cherry Girl 3 with" , 200, 200);
        im.setColor(Color.red);
        im.drawString("   High Score",430,200);
        font = new Font("Arial", Font.BOLD, 15);
        im.setFont(font);
        im.setColor(Color.black);
        im.drawString("Click \"Run\" to Start..." , 320, 280);
        setBackground(im); 

        scrollX=0;
        tick=0;
        time=0;
        tempTime=0;
        canShowRank=false;
        isPaused=false;
    }

    public void init(){   
        firstTile=new tile(0);
        firstTile.setImage("start.png");
        controller con=new controller();
        con.getImage().setTransparency(0);
        //         int x = Greenfoot.getRandomNumber(getWidth()-2*tile.SIZE)/tile.SIZE*tile.SIZE+tile.SIZE/2;
        //         int y = (tile.SIZE+Greenfoot.getRandomNumber(getHeight()-tile.SIZE))/tile.SIZE*tile.SIZE+tile.SIZE/2;
        int firstX=32;
        int firstY=288;
        addObject(firstTile, firstX,firstY);
        addObject ( new Girl(), firstX, firstY-tile.SIZE);
        addObject(new ControlPanel(2*tile.SIZE,getHeight()),getWidth()-tile.SIZE,getHeight()/2);
        addObject(con,352,352);
        //         addObject(new tile(0),32,480);
        //         addObject(new Girl(),32,480-64);
        addObject(new StaTile(1,3),getWidth()-tile.SIZE,getHeight()/3);
        addObject(new StaTile(0,8),getWidth()-tile.SIZE,getHeight()/3*2);

        lastX=firstX;
        lastY=firstY;

        setPaintOrder(ScoreBoard.class,MyScoreBoard.class,controller.class,Girl.class,StaTile.class,ControlPanel.class,tile.class,Cherry.class);
        setActOrder(StaTile.class,Girl.class,CherryWorld.class,Cherry.class,ControlPanel.class);
        createTiles();
        randomCherries(TOTALCHERRIES);
        showNum();       

    }

    public void addTile(){  //create new tile by the current direction
        switch(direction){
            case East:lastX=lastX+tile.SIZE;break;
            case North:lastY=lastY-tile.SIZE;break;
            case South:lastY=lastY+tile.SIZE;break;
        }
        if(Greenfoot.getRandomNumber(100)<80 )
            addObject(new tile(0), lastX, lastY);
    }

    public void changeDir(){  //Randomly change the direction for creating new tile
        switch(direction){
            case East:if(Greenfoot.getRandomNumber(100)<20 && lastY>=tile.SIZE*5/2)
                direction=Dir.North;
            else if(Greenfoot.getRandomNumber(100)<20 && lastY<=getHeight()-tile.SIZE*3/2)
                direction=Dir.South;
            break;
            case South:if(Greenfoot.getRandomNumber(100)<20 && lastY<=getHeight()-tile.SIZE*3/2)
                direction=Dir.South;
            else
                direction=Dir.East;
            break;
            case North:if(Greenfoot.getRandomNumber(100)<20 && lastY>=tile.SIZE*5/2)
                direction=Dir.North;
            else
                direction=Dir.East;
            break;
        }
    }

    public void createTiles(){  //Randomly creating the world of tiles
        while(lastX<=MapWidth){
            addTile();
            changeDir();  
        }
    }

    //         public void act()   {      
    //         if(Greenfoot.mouseMoved(null)){
    //             greenfoot.MouseInfo mouse = Greenfoot.getMouseInfo();
    //             if(con==null){
    //                 con=new controller();
    //                 con.getImage().setTransparency(100);
    //                 addObject(con,mouse.getX()/tile.SIZE*tile.SIZE+tile.SIZE/2, mouse.getY()/tile.SIZE*tile.SIZE+tile.SIZE/2);
    //             }              
    //         }
    //     }

    public void showNum(){
        List list=this.getObjects(StaTile.class);
        for(Object st:list)
            showText("×"+((StaTile)st).getCount(), ((StaTile)st).getX(), ((StaTile)st).getY()+55);
    }

    public void randomCherries(int howMany)
    {   
        int i=0;
        int x,y;
        List t;
        while(i<howMany) {
            x = Greenfoot.getRandomNumber(MapWidth)/tile.SIZE*tile.SIZE+tile.SIZE/2;
            y = Greenfoot.getRandomNumber(getHeight()-tile.SIZE)/tile.SIZE*tile.SIZE+tile.SIZE/2;
            t=getObjectsAt(x,y,null);
            if(t.size()==0&&!nearOthers(x,y)){
                Cherry cherry = new Cherry(x,y);
                addObject(cherry, x, y);
                i++;
            }
        }     
    }

    public boolean nearOthers(int x, int y){  //check if two cherries are too near
        List cherries=getObjects(Cherry.class);
        if(cherries.isEmpty()) 
            return false;
        int i=0;
        for(;i<cherries.size();i++){
            Cherry cherry =(Cherry)cherries.get(i);
            if(((cherry.getInitX()-x)*(cherry.getInitX()-x)+(cherry.getInitY()-y)*(cherry.getInitY()-y))<9*tile.SIZE*tile.SIZE)
                break;
        }
        if(i==cherries.size())
            return false;
        else 
            return true;
    }

    public void gameOver(String title) {
        if(canShowRank==true){
            showRank();
            Greenfoot.stop();
            if(UserInfo.getMyInfo().getUserName()!=null){
                //                 removeObjects(getObjects(MyScoreBoard.class));
            }
        }
        else{

            MyScoreBoard mboard=new MyScoreBoard(title,time);
            addObject(mboard, getWidth()/2, getHeight()/2);
            if(title.equals("Finished!"))
                canShowRank=true;
        }
    }

    public void started(){
        if(isPaused){     
            isPaused=false;  
        }
        else{
            setBackground("clouds.png");
            init();
        }
        tick=System.nanoTime();
    }

    public void stopped(){
        tempTime=time;
        isPaused=true;
    }

    public void showRank(){
        if(UserInfo.isStorageAvailable()) {
            if(UserInfo.getMyInfo() != null) {
                UserInfo player = UserInfo.getMyInfo();
                if(player.getScore()==0||player.getScore() < -(int)time) {
                    player.setScore(-(int)time);
                    player.store();
                }
            }
        }      
        addObject(new ScoreBoard(getWidth(), getHeight()), getWidth()/2, getHeight()/2);
    }
// 
//     public void resetBackIm(){
//         GreenfootImage back=getBackground();
//         back.drawImage(backIm1, scrollX, 0);
//         back.drawImage(backIm2, scrollX+getWidth()-150, 0);
//     }
// 
//     public void scrollBackground(){
//         if(canScrollLeft && Greenfoot.isKeyDown("d")){
//             scrollX-=2;
//             resetBackIm();
//         }
//         else if(canScrollRight && Greenfoot.isKeyDown("a")){
//             scrollX+=2;
//             resetBackIm();
//         }
//     }

    public void act()   {   
//         scrollBackground();
        if(!isPaused){
            time=tempTime+(System.nanoTime()-tick)/1000000000L;
        }          
        showText("Time:"+time+"s",700,50);
    }
}
