import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * A little Girlin that wants to get to the other side.
 */
public class Girl extends Mover
{
    private static final int jumpStrength = 16;
    private boolean canRunRight=true;
    private boolean canMove=true;
    private boolean moveFlag=false;
    private int  cherriesEaten=0;
    private tile t;
    private Actor cherry;
    boolean canJump=false;

    public void act() 
    {
        //         if(Greenfoot.isKeyDown("space"))
        //             canMove=true;
        if(canMove){
            checkGameover();
            move();  
            checkFall();
            checkCollision();
            if(foundCherry()) eatCherry();
        }
    }

    public  void checkCollision() {
        if(isTouching(ControlPanel.class))
        //             setLocation(640-64-95,getY());
            setLocation(getWorld().getWidth()-getImage().getWidth()/2-getOneIntersectingObject(ControlPanel.class).getImage().getWidth(), getY());

        if (blockTop()) {
            setVSpeed(0);
            t=(tile)getOneObjectAtOffset(0 ,-getImage().getHeight()/2, tile.class);
            if (t!=null) 
                setLocation ( getX(), t.getY() + t.getImage().getHeight()/2+getImage().getHeight()/2);
        } 
        //             else if(getY()<getImage().getHeight()/2)
        //                 setLocation ( getX(),getImage().getHeight()/2) ;    

        //         if(blockRight()||getX()>(getWorld().getWidth()-getImage().getWidth()/2)) { 
        //             canRunRight=false;
        // //             setImage("left1.png"); 
        //         }
        //         if(blockLeft()||getX()<getImage().getWidth()/2) { 
        //             canRunRight=true;
        // //             setImage("right1.png");
        //         }

    }

    private void move()
    {
        moveHorizontally();
        moveVertically();
    }    

    //dealing with the “true” more and “relative” move horizontally
    public void moveHorizontally(){ 
        if( Greenfoot.isKeyDown("d")) { 
            if(moveFlag) setImage("right2.png");
            else setImage("right1.png");

            t=(tile)getOneObjectAtOffset(getImage().getWidth()/2 ,0, tile.class);
            if (t==null&&CherryWorld.firstTile.getX()>-672&&getX()>320)
                CherryWorld.canScrollLeft=true;
            else
                CherryWorld.canScrollLeft=false;

            if(!CherryWorld.canScrollLeft&&t==null)
                moveRight();
            else if(CherryWorld.canScrollLeft){
                CherryWorld.scrollX-=2;
                resetBackground();
            }
        }

        if(Greenfoot.isKeyDown("a")){       
            if(moveFlag) setImage("left2.png");
            else setImage("left1.png");

            t=(tile)getOneObjectAtOffset(-getImage().getWidth()/2 ,0, tile.class);
            if (t==null&&CherryWorld.firstTile.getX()<32&&getX()<=320) 
                CherryWorld.canScrollRight=true;
            else
                CherryWorld.canScrollRight=false;

            if(!CherryWorld.canScrollRight&&getX()>32&&t==null)
                moveLeft();
            else if(CherryWorld.canScrollRight){
                CherryWorld.scrollX+=2;
                resetBackground();
            }
        }
    }

    //dealing with the jumping vertically
    public void moveVertically(){
        if(Greenfoot.isKeyDown("w")&&canJump==true){   
            Greenfoot.playSound("jump.wav");
            jump();
        }

        if(onGround()){
            moveFlag=!moveFlag;
            canJump=true;
        }
        else canJump=false;

        t=(tile)getOneObjectAtOffset(0, getImage().getHeight()/2 , tile.class);
        if (t!=null&&t.gettype()==1){  
            Greenfoot.playSound("jump.wav");
            jump();
        }       
    }

    public void resetBackground(){
        GreenfootImage back=getWorld().getBackground();
        back.drawImage(CherryWorld.backIm1, CherryWorld.scrollX, 0);
        back.drawImage(CherryWorld.backIm2, CherryWorld.scrollX+getWorld().getWidth()-170, 0);
    }

    private void jump()
    {
        canJump=false;
        setVSpeed(-jumpStrength);
        fall();
    }

    private void checkFall()
    {
        if (onGround()) {
            t=(tile)getOneObjectAtOffset(0, getImage().getHeight()/2 , tile.class);
            if (t!=null) 
                setLocation ( getX(), t.getY()-getImage().getHeight()/2-getImage().getHeight()/2);
            setVSpeed(0);
        }
        else {
            fall();
        }
    }

    public boolean foundCherry()
    {
        cherry = getOneIntersectingObject( Cherry.class);
        if(cherry  != null) {
            return true;
        }
        else {
            return false;
        }
    }

    public void eatCherry()
    {
        cherry  = getOneIntersectingObject( Cherry.class);
        if(cherry  != null) {
            Greenfoot.playSound("eat.wav");
            getWorld().removeObject(cherry);
            cherriesEaten =cherriesEaten + 1; 
        }
    }

    public int getCherries()   {
        return  cherriesEaten;
    }

    public void checkGameover() {
        if(cherriesEaten==((CherryWorld)getWorld()).TOTALCHERRIES){
            ((CherryWorld)getWorld()).gameOver("Finished!");
        }
    }
}
